require 'aes'
#require 'profile'

input = "\x00\x11\x22\x33\x44\x55\x66\x77\x88\x99\xaa\xbb\xcc\xdd\xee\xff"

iv = [[0,1,2,3],[4,5,6,7],[8,9,0,1],[2,3,4,5]]

print "INPUT                    = "
input.each_byte { |c| print "%02x " % c }
puts

puts

key = "\x00\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
print "AES_128 KEY = "
key.each_byte { |c| print "%02x" % c }
puts

aes = Aes.new(128,'ECB', key)
output1 = aes.cypherEncrypt(input)
print "AES_128 ECB MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
output2 = aes.cypherDecrypt(output1)
print "AES_128 ECB MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts

aes = Aes.new(128,'CBC', key)
aes.cypherIV(iv)
output1 = aes.cypherEncrypt(input)
print "AES_128 CBC MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
aes.cypherIV(iv)
output2 = aes.cypherDecrypt(output1)
print "AES_128 CBC MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts

aes = Aes.new(128,'OFB', key)
aes.cypherIV(iv)
output1 = aes.cypherEncrypt(input)
print "AES_128 OFB MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
aes.cypherIV(iv)
output2 = aes.cypherDecrypt(output1)
print "AES_128 OFB MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts

aes = Aes.new(128,'CFB', key)
aes.cypherIV(iv)
output1 = aes.cypherEncrypt(input)
print "AES_128 CFB MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
aes.cypherIV(iv)
output2 = aes.cypherDecrypt(output1)
print "AES_128 CFB MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts


puts

key = "\x00\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17"
print "AES_192 KEY = "
key.each_byte { |c| print "%02x" % c }
puts

aes = Aes.new(192,'ECB', key)
output1 = aes.cypherEncrypt(input)
print "AES_192 ECB MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
output2 = aes.cypherDecrypt(output1)
print "AES_192 ECB MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts

aes = Aes.new(192,'CBC', key)
aes.cypherIV(iv)
output1 = aes.cypherEncrypt(input)
print "AES_192 CBC MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
aes.cypherIV(iv)
output2 = aes.cypherDecrypt(output1)
print "AES_192 CBC MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts

aes = Aes.new(192,'OFB', key)
aes.cypherIV(iv)
output1 = aes.cypherEncrypt(input)
print "AES_192 OFB MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
aes.cypherIV(iv)
output2 = aes.cypherDecrypt(output1)
print "AES_192 OFB MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts

aes = Aes.new(192,'CFB', key)
aes.cypherIV(iv)
output1 = aes.cypherEncrypt(input)
print "AES_192 CFB MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
aes.cypherIV(iv)
output2 = aes.cypherDecrypt(output1)
print "AES_192 CFB MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts

puts

key = "\x00\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
print "AES_256 KEY = "
key.each_byte { |c| print "%02x" % c }
puts

aes = Aes.new(256,'ECB', key)
output1 = aes.cypherEncrypt(input)
print "AES_256 ECB MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
output2 = aes.cypherDecrypt(output1)
print "AES_256 ECB MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts

aes = Aes.new(256,'CBC', key)
aes.cypherIV(iv)
output1 = aes.cypherEncrypt(input)
print "AES_256 CBC MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
aes.cypherIV(iv)
output2 = aes.cypherDecrypt(output1)
print "AES_256 CBC MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts

aes = Aes.new(256,'OFB', key)
aes.cypherIV(iv)
output1 = aes.cypherEncrypt(input)
print "AES_256 OFB MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
aes.cypherIV(iv)
output2 = aes.cypherDecrypt(output1)
print "AES_256 OFB MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts

aes = Aes.new(256,'CFB', key)
aes.cypherIV(iv)
output1 = aes.cypherEncrypt(input)
print "AES_256 CFB MODE ENCRYPT = "
output1.each_byte { |c| print "%02x " % c }
puts
aes.cypherIV(iv)
output2 = aes.cypherDecrypt(output1)
print "AES_256 CFB MODE DECRYPT = "
output2.each_byte { |c| print "%02x " % c }
puts

key = "\x00\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
print "Encryption of file: aes-test.rb..."
Aes.encryptFile(128,'ECB',key,nil,"aes-test.rb","aes-test.rb.aes")
puts "done !"
print "Decryption of file: aes-test.rb.aes..."
Aes.decryptFile(128,'ECB',key,nil,"aes-test.rb.aes","aes-test.rb.out")
puts "done !"
